// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package vacancies

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// VacanciesClient is the client API for Vacancies service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type VacanciesClient interface {
	// CreateVacancy creates a vacancy in the database and notifies subscribers
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	CreateVacancy(ctx context.Context, in *Vacancy, opts ...grpc.CallOption) (*Vacancy, error)
	// UpdateVacancy updates a vacancy in the database and notifies subscribers
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	UpdateVacancy(ctx context.Context, in *Vacancy, opts ...grpc.CallOption) (*Vacancy, error)
	// GetVacancy creates a vacancy in the database and notifies subscribers
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	GetVacancy(ctx context.Context, in *GetVacancyRequest, opts ...grpc.CallOption) (*Vacancy, error)
	// DeleteVacancy deletes a vacancy in the database
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	DeleteVacancy(ctx context.Context, in *GetVacancyRequest, opts ...grpc.CallOption) (*Vacancy, error)
	// ListVacancies returns all vacancies that match a filter
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	ListVacancies(ctx context.Context, in *ListVacanciesRequest, opts ...grpc.CallOption) (*ListVacanciesReply, error)
	// ApplyToVacancy sends an email to the contact of a vacancy
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	ApplyToVacancy(ctx context.Context, in *Application, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// CreateSubscription creates a subscription for a vacancy filter
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	CreateSubscription(ctx context.Context, in *Subscription, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// ListSubscriptions gets all subscriptions for the authorized user
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	ListSubscriptions(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*ListSubscriptionsReply, error)
	// DeleteAllSubscriptions deletes all subscriptions for the logged in user
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	DeleteAllSubscriptions(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error)
}

type vacanciesClient struct {
	cc grpc.ClientConnInterface
}

func NewVacanciesClient(cc grpc.ClientConnInterface) VacanciesClient {
	return &vacanciesClient{cc}
}

func (c *vacanciesClient) CreateVacancy(ctx context.Context, in *Vacancy, opts ...grpc.CallOption) (*Vacancy, error) {
	out := new(Vacancy)
	err := c.cc.Invoke(ctx, "/vseth.sek.vacancies.Vacancies/CreateVacancy", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vacanciesClient) UpdateVacancy(ctx context.Context, in *Vacancy, opts ...grpc.CallOption) (*Vacancy, error) {
	out := new(Vacancy)
	err := c.cc.Invoke(ctx, "/vseth.sek.vacancies.Vacancies/UpdateVacancy", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vacanciesClient) GetVacancy(ctx context.Context, in *GetVacancyRequest, opts ...grpc.CallOption) (*Vacancy, error) {
	out := new(Vacancy)
	err := c.cc.Invoke(ctx, "/vseth.sek.vacancies.Vacancies/GetVacancy", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vacanciesClient) DeleteVacancy(ctx context.Context, in *GetVacancyRequest, opts ...grpc.CallOption) (*Vacancy, error) {
	out := new(Vacancy)
	err := c.cc.Invoke(ctx, "/vseth.sek.vacancies.Vacancies/DeleteVacancy", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vacanciesClient) ListVacancies(ctx context.Context, in *ListVacanciesRequest, opts ...grpc.CallOption) (*ListVacanciesReply, error) {
	out := new(ListVacanciesReply)
	err := c.cc.Invoke(ctx, "/vseth.sek.vacancies.Vacancies/ListVacancies", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vacanciesClient) ApplyToVacancy(ctx context.Context, in *Application, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.sek.vacancies.Vacancies/ApplyToVacancy", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vacanciesClient) CreateSubscription(ctx context.Context, in *Subscription, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.sek.vacancies.Vacancies/CreateSubscription", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vacanciesClient) ListSubscriptions(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*ListSubscriptionsReply, error) {
	out := new(ListSubscriptionsReply)
	err := c.cc.Invoke(ctx, "/vseth.sek.vacancies.Vacancies/ListSubscriptions", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *vacanciesClient) DeleteAllSubscriptions(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.sek.vacancies.Vacancies/DeleteAllSubscriptions", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// VacanciesServer is the server API for Vacancies service.
// All implementations must embed UnimplementedVacanciesServer
// for forward compatibility
type VacanciesServer interface {
	// CreateVacancy creates a vacancy in the database and notifies subscribers
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	CreateVacancy(context.Context, *Vacancy) (*Vacancy, error)
	// UpdateVacancy updates a vacancy in the database and notifies subscribers
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	UpdateVacancy(context.Context, *Vacancy) (*Vacancy, error)
	// GetVacancy creates a vacancy in the database and notifies subscribers
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	GetVacancy(context.Context, *GetVacancyRequest) (*Vacancy, error)
	// DeleteVacancy deletes a vacancy in the database
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	DeleteVacancy(context.Context, *GetVacancyRequest) (*Vacancy, error)
	// ListVacancies returns all vacancies that match a filter
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	ListVacancies(context.Context, *ListVacanciesRequest) (*ListVacanciesReply, error)
	// ApplyToVacancy sends an email to the contact of a vacancy
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	ApplyToVacancy(context.Context, *Application) (*emptypb.Empty, error)
	// CreateSubscription creates a subscription for a vacancy filter
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	CreateSubscription(context.Context, *Subscription) (*emptypb.Empty, error)
	// ListSubscriptions gets all subscriptions for the authorized user
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	ListSubscriptions(context.Context, *emptypb.Empty) (*ListSubscriptionsReply, error)
	// DeleteAllSubscriptions deletes all subscriptions for the logged in user
	//
	//  Arguments:
	//
	//  Returns:
	//
	//  Exceptions:
	//
	DeleteAllSubscriptions(context.Context, *emptypb.Empty) (*emptypb.Empty, error)
	mustEmbedUnimplementedVacanciesServer()
}

// UnimplementedVacanciesServer must be embedded to have forward compatible implementations.
type UnimplementedVacanciesServer struct {
}

func (UnimplementedVacanciesServer) CreateVacancy(context.Context, *Vacancy) (*Vacancy, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateVacancy not implemented")
}
func (UnimplementedVacanciesServer) UpdateVacancy(context.Context, *Vacancy) (*Vacancy, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateVacancy not implemented")
}
func (UnimplementedVacanciesServer) GetVacancy(context.Context, *GetVacancyRequest) (*Vacancy, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetVacancy not implemented")
}
func (UnimplementedVacanciesServer) DeleteVacancy(context.Context, *GetVacancyRequest) (*Vacancy, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteVacancy not implemented")
}
func (UnimplementedVacanciesServer) ListVacancies(context.Context, *ListVacanciesRequest) (*ListVacanciesReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListVacancies not implemented")
}
func (UnimplementedVacanciesServer) ApplyToVacancy(context.Context, *Application) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ApplyToVacancy not implemented")
}
func (UnimplementedVacanciesServer) CreateSubscription(context.Context, *Subscription) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateSubscription not implemented")
}
func (UnimplementedVacanciesServer) ListSubscriptions(context.Context, *emptypb.Empty) (*ListSubscriptionsReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListSubscriptions not implemented")
}
func (UnimplementedVacanciesServer) DeleteAllSubscriptions(context.Context, *emptypb.Empty) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteAllSubscriptions not implemented")
}
func (UnimplementedVacanciesServer) mustEmbedUnimplementedVacanciesServer() {}

// UnsafeVacanciesServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to VacanciesServer will
// result in compilation errors.
type UnsafeVacanciesServer interface {
	mustEmbedUnimplementedVacanciesServer()
}

func RegisterVacanciesServer(s grpc.ServiceRegistrar, srv VacanciesServer) {
	s.RegisterService(&Vacancies_ServiceDesc, srv)
}

func _Vacancies_CreateVacancy_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Vacancy)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VacanciesServer).CreateVacancy(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sek.vacancies.Vacancies/CreateVacancy",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VacanciesServer).CreateVacancy(ctx, req.(*Vacancy))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vacancies_UpdateVacancy_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Vacancy)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VacanciesServer).UpdateVacancy(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sek.vacancies.Vacancies/UpdateVacancy",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VacanciesServer).UpdateVacancy(ctx, req.(*Vacancy))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vacancies_GetVacancy_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetVacancyRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VacanciesServer).GetVacancy(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sek.vacancies.Vacancies/GetVacancy",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VacanciesServer).GetVacancy(ctx, req.(*GetVacancyRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vacancies_DeleteVacancy_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetVacancyRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VacanciesServer).DeleteVacancy(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sek.vacancies.Vacancies/DeleteVacancy",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VacanciesServer).DeleteVacancy(ctx, req.(*GetVacancyRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vacancies_ListVacancies_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListVacanciesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VacanciesServer).ListVacancies(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sek.vacancies.Vacancies/ListVacancies",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VacanciesServer).ListVacancies(ctx, req.(*ListVacanciesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vacancies_ApplyToVacancy_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Application)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VacanciesServer).ApplyToVacancy(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sek.vacancies.Vacancies/ApplyToVacancy",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VacanciesServer).ApplyToVacancy(ctx, req.(*Application))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vacancies_CreateSubscription_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Subscription)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VacanciesServer).CreateSubscription(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sek.vacancies.Vacancies/CreateSubscription",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VacanciesServer).CreateSubscription(ctx, req.(*Subscription))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vacancies_ListSubscriptions_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VacanciesServer).ListSubscriptions(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sek.vacancies.Vacancies/ListSubscriptions",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VacanciesServer).ListSubscriptions(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _Vacancies_DeleteAllSubscriptions_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(VacanciesServer).DeleteAllSubscriptions(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sek.vacancies.Vacancies/DeleteAllSubscriptions",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(VacanciesServer).DeleteAllSubscriptions(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

// Vacancies_ServiceDesc is the grpc.ServiceDesc for Vacancies service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Vacancies_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.sek.vacancies.Vacancies",
	HandlerType: (*VacanciesServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateVacancy",
			Handler:    _Vacancies_CreateVacancy_Handler,
		},
		{
			MethodName: "UpdateVacancy",
			Handler:    _Vacancies_UpdateVacancy_Handler,
		},
		{
			MethodName: "GetVacancy",
			Handler:    _Vacancies_GetVacancy_Handler,
		},
		{
			MethodName: "DeleteVacancy",
			Handler:    _Vacancies_DeleteVacancy_Handler,
		},
		{
			MethodName: "ListVacancies",
			Handler:    _Vacancies_ListVacancies_Handler,
		},
		{
			MethodName: "ApplyToVacancy",
			Handler:    _Vacancies_ApplyToVacancy_Handler,
		},
		{
			MethodName: "CreateSubscription",
			Handler:    _Vacancies_CreateSubscription_Handler,
		},
		{
			MethodName: "ListSubscriptions",
			Handler:    _Vacancies_ListSubscriptions_Handler,
		},
		{
			MethodName: "DeleteAllSubscriptions",
			Handler:    _Vacancies_DeleteAllSubscriptions_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "vseth/sek/vacancies/vacancies.proto",
}
